import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataIbmcpdSpAssetsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifer for service provider.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/d/sp_assets#service_provider_id DataIbmcpdSpAssets#service_provider_id}
    */
    readonly serviceProviderId: string;
}
export interface DataIbmcpdSpAssetsSpAssets {
}
export declare function dataIbmcpdSpAssetsSpAssetsToTerraform(struct?: DataIbmcpdSpAssetsSpAssets): any;
export declare class DataIbmcpdSpAssetsSpAssetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataIbmcpdSpAssetsSpAssets | undefined;
    set internalValue(value: DataIbmcpdSpAssetsSpAssets | undefined);
    get assetId(): string;
    get deploymentId(): string;
    get deploymentRn(): string;
    get name(): string;
}
export declare class DataIbmcpdSpAssetsSpAssetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataIbmcpdSpAssetsSpAssetsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/ibmcpd/d/sp_assets ibmcpd_sp_assets}
*/
export declare class DataIbmcpdSpAssets extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "ibmcpd_sp_assets";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/ibmcpd/d/sp_assets ibmcpd_sp_assets} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataIbmcpdSpAssetsConfig
    */
    constructor(scope: Construct, id: string, config: DataIbmcpdSpAssetsConfig);
    get id(): string;
    private _serviceProviderId?;
    get serviceProviderId(): string;
    set serviceProviderId(value: string);
    get serviceProviderIdInput(): string | undefined;
    private _spAssets;
    get spAssets(): DataIbmcpdSpAssetsSpAssetsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
