import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DeploymentConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment#asset Deployment#asset}
    */
    readonly asset?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment#batch Deployment#batch}
    */
    readonly batch?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment#name Deployment#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment#online Deployment#online}
    */
    readonly online?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment#serving_url Deployment#serving_url}
    */
    readonly servingUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment#space_id Deployment#space_id}
    */
    readonly spaceId: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment ibmcpd_deployment}
*/
export declare class Deployment extends cdktf.TerraformResource {
    static readonly tfResourceType = "ibmcpd_deployment";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/ibmcpd/r/deployment ibmcpd_deployment} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DeploymentConfig
    */
    constructor(scope: Construct, id: string, config: DeploymentConfig);
    private _asset?;
    get asset(): string;
    set asset(value: string);
    resetAsset(): void;
    get assetInput(): string | undefined;
    private _batch?;
    get batch(): boolean | cdktf.IResolvable;
    set batch(value: boolean | cdktf.IResolvable);
    resetBatch(): void;
    get batchInput(): boolean | cdktf.IResolvable | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _online?;
    get online(): boolean | cdktf.IResolvable;
    set online(value: boolean | cdktf.IResolvable);
    resetOnline(): void;
    get onlineInput(): boolean | cdktf.IResolvable | undefined;
    private _servingUrl?;
    get servingUrl(): string;
    set servingUrl(value: string);
    resetServingUrl(): void;
    get servingUrlInput(): string | undefined;
    private _spaceId?;
    get spaceId(): string;
    set spaceId(value: string);
    get spaceIdInput(): string | undefined;
    get url(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
