import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MonitorInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#data_mart_id MonitorInstance#data_mart_id}
    */
    readonly dataMartId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#drift_archive_path MonitorInstance#drift_archive_path}
    */
    readonly driftArchivePath?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#monitor_definition_id MonitorInstance#monitor_definition_id}
    */
    readonly monitorDefinitionId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#parameters MonitorInstance#parameters}
    */
    readonly parameters?: MonitorInstanceParameters | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#subscription_id MonitorInstance#subscription_id}
    */
    readonly subscriptionId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#thresholds MonitorInstance#thresholds}
    */
    readonly thresholds?: MonitorInstanceThresholds[] | cdktf.IResolvable;
}
export interface MonitorInstanceParametersFeatures {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#feature MonitorInstance#feature}
    */
    readonly feature?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#majority MonitorInstance#majority}
    */
    readonly majority?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#minority MonitorInstance#minority}
    */
    readonly minority?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#threshold MonitorInstance#threshold}
    */
    readonly threshold?: number;
}
export declare function monitorInstanceParametersFeaturesToTerraform(struct?: MonitorInstanceParametersFeatures | cdktf.IResolvable): any;
export declare class MonitorInstanceParametersFeaturesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MonitorInstanceParametersFeatures | cdktf.IResolvable | undefined;
    set internalValue(value: MonitorInstanceParametersFeatures | cdktf.IResolvable | undefined);
    private _feature?;
    get feature(): string;
    set feature(value: string);
    resetFeature(): void;
    get featureInput(): string | undefined;
    private _majority?;
    get majority(): string[];
    set majority(value: string[]);
    resetMajority(): void;
    get majorityInput(): string[] | undefined;
    private _minority?;
    get minority(): string[];
    set minority(value: string[]);
    resetMinority(): void;
    get minorityInput(): string[] | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    resetThreshold(): void;
    get thresholdInput(): number | undefined;
}
export declare class MonitorInstanceParametersFeaturesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MonitorInstanceParametersFeatures[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MonitorInstanceParametersFeaturesOutputReference;
}
export interface MonitorInstanceParameters {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#drift_threshold MonitorInstance#drift_threshold}
    */
    readonly driftThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#enable_data_drift MonitorInstance#enable_data_drift}
    */
    readonly enableDataDrift?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#enable_model_drift MonitorInstance#enable_model_drift}
    */
    readonly enableModelDrift?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#enabled MonitorInstance#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#favourable_class MonitorInstance#favourable_class}
    */
    readonly favourableClass?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#features MonitorInstance#features}
    */
    readonly features?: MonitorInstanceParametersFeatures[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#min_feedback_data_size MonitorInstance#min_feedback_data_size}
    */
    readonly minFeedbackDataSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#min_records MonitorInstance#min_records}
    */
    readonly minRecords?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#min_samples MonitorInstance#min_samples}
    */
    readonly minSamples?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#train_drift_model MonitorInstance#train_drift_model}
    */
    readonly trainDriftModel?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#unfavourable_class MonitorInstance#unfavourable_class}
    */
    readonly unfavourableClass?: string[];
}
export declare function monitorInstanceParametersToTerraform(struct?: MonitorInstanceParameters | cdktf.IResolvable): any;
export declare class MonitorInstanceParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MonitorInstanceParameters | cdktf.IResolvable | undefined;
    set internalValue(value: MonitorInstanceParameters | cdktf.IResolvable | undefined);
    private _driftThreshold?;
    get driftThreshold(): number;
    set driftThreshold(value: number);
    resetDriftThreshold(): void;
    get driftThresholdInput(): number | undefined;
    private _enableDataDrift?;
    get enableDataDrift(): boolean | cdktf.IResolvable;
    set enableDataDrift(value: boolean | cdktf.IResolvable);
    resetEnableDataDrift(): void;
    get enableDataDriftInput(): boolean | cdktf.IResolvable | undefined;
    private _enableModelDrift?;
    get enableModelDrift(): boolean | cdktf.IResolvable;
    set enableModelDrift(value: boolean | cdktf.IResolvable);
    resetEnableModelDrift(): void;
    get enableModelDriftInput(): boolean | cdktf.IResolvable | undefined;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _favourableClass?;
    get favourableClass(): string[];
    set favourableClass(value: string[]);
    resetFavourableClass(): void;
    get favourableClassInput(): string[] | undefined;
    private _features;
    get features(): MonitorInstanceParametersFeaturesList;
    putFeatures(value: MonitorInstanceParametersFeatures[] | cdktf.IResolvable): void;
    resetFeatures(): void;
    get featuresInput(): cdktf.IResolvable | MonitorInstanceParametersFeatures[] | undefined;
    private _minFeedbackDataSize?;
    get minFeedbackDataSize(): number;
    set minFeedbackDataSize(value: number);
    resetMinFeedbackDataSize(): void;
    get minFeedbackDataSizeInput(): number | undefined;
    private _minRecords?;
    get minRecords(): number;
    set minRecords(value: number);
    resetMinRecords(): void;
    get minRecordsInput(): number | undefined;
    private _minSamples?;
    get minSamples(): number;
    set minSamples(value: number);
    resetMinSamples(): void;
    get minSamplesInput(): number | undefined;
    private _trainDriftModel?;
    get trainDriftModel(): boolean | cdktf.IResolvable;
    set trainDriftModel(value: boolean | cdktf.IResolvable);
    resetTrainDriftModel(): void;
    get trainDriftModelInput(): boolean | cdktf.IResolvable | undefined;
    private _unfavourableClass?;
    get unfavourableClass(): string[];
    set unfavourableClass(value: string[]);
    resetUnfavourableClass(): void;
    get unfavourableClassInput(): string[] | undefined;
}
export interface MonitorInstanceThresholds {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#metric_id MonitorInstance#metric_id}
    */
    readonly metricId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#type MonitorInstance#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance#value MonitorInstance#value}
    */
    readonly value?: number;
}
export declare function monitorInstanceThresholdsToTerraform(struct?: MonitorInstanceThresholds | cdktf.IResolvable): any;
export declare class MonitorInstanceThresholdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MonitorInstanceThresholds | cdktf.IResolvable | undefined;
    set internalValue(value: MonitorInstanceThresholds | cdktf.IResolvable | undefined);
    private _metricId?;
    get metricId(): string;
    set metricId(value: string);
    resetMetricId(): void;
    get metricIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _value?;
    get value(): number;
    set value(value: number);
    resetValue(): void;
    get valueInput(): number | undefined;
}
export declare class MonitorInstanceThresholdsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MonitorInstanceThresholds[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MonitorInstanceThresholdsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance ibmcpd_monitor_instance}
*/
export declare class MonitorInstance extends cdktf.TerraformResource {
    static readonly tfResourceType = "ibmcpd_monitor_instance";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/ibmcpd/r/monitor_instance ibmcpd_monitor_instance} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MonitorInstanceConfig
    */
    constructor(scope: Construct, id: string, config: MonitorInstanceConfig);
    private _dataMartId?;
    get dataMartId(): string;
    set dataMartId(value: string);
    get dataMartIdInput(): string | undefined;
    private _driftArchivePath?;
    get driftArchivePath(): string;
    set driftArchivePath(value: string);
    resetDriftArchivePath(): void;
    get driftArchivePathInput(): string | undefined;
    get id(): string;
    private _monitorDefinitionId?;
    get monitorDefinitionId(): string;
    set monitorDefinitionId(value: string);
    get monitorDefinitionIdInput(): string | undefined;
    private _parameters;
    get parameters(): MonitorInstanceParametersOutputReference;
    putParameters(value: MonitorInstanceParameters | cdktf.IResolvable): void;
    resetParameters(): void;
    get parametersInput(): cdktf.IResolvable | MonitorInstanceParameters | undefined;
    private _subscriptionId?;
    get subscriptionId(): string;
    set subscriptionId(value: string);
    get subscriptionIdInput(): string | undefined;
    private _thresholds;
    get thresholds(): MonitorInstanceThresholdsList;
    putThresholds(value: MonitorInstanceThresholds[] | cdktf.IResolvable): void;
    resetThresholds(): void;
    get thresholdsInput(): cdktf.IResolvable | MonitorInstanceThresholds[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
