import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IbmcpdProviderConfig {
    /**
    * API key for IBM Cloud Pak for Data.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd#api_key IbmcpdProvider#api_key}
    */
    readonly apiKey?: string;
    /**
    * Password for IBM Cloud Pak for Data.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd#password IbmcpdProvider#password}
    */
    readonly password?: string;
    /**
    * URL for IBM Cloud Pak for Data.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd#url IbmcpdProvider#url}
    */
    readonly url: string;
    /**
    * Username for IBM Cloud Pak for Data.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd#username IbmcpdProvider#username}
    */
    readonly username?: string;
    /**
    * Alias name
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd#alias IbmcpdProvider#alias}
    */
    readonly alias?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/ibmcpd ibmcpd}
*/
export declare class IbmcpdProvider extends cdktf.TerraformProvider {
    static readonly tfResourceType = "ibmcpd";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/ibmcpd ibmcpd} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IbmcpdProviderConfig
    */
    constructor(scope: Construct, id: string, config: IbmcpdProviderConfig);
    private _apiKey?;
    get apiKey(): string | undefined;
    set apiKey(value: string | undefined);
    resetApiKey(): void;
    get apiKeyInput(): string | undefined;
    private _password?;
    get password(): string | undefined;
    set password(value: string | undefined);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _url?;
    get url(): string | undefined;
    set url(value: string | undefined);
    get urlInput(): string | undefined;
    private _username?;
    get username(): string | undefined;
    set username(value: string | undefined);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    private _alias?;
    get alias(): string | undefined;
    set alias(value: string | undefined);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
