import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ServiceProviderConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#api_key ServiceProvider#api_key}
    */
    readonly apiKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#aws_access_key_id ServiceProvider#aws_access_key_id}
    */
    readonly awsAccessKeyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#aws_region ServiceProvider#aws_region}
    */
    readonly awsRegion?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#aws_secret_access_key ServiceProvider#aws_secret_access_key}
    */
    readonly awsSecretAccessKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#deployment_space_id ServiceProvider#deployment_space_id}
    */
    readonly deploymentSpaceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#name ServiceProvider#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#operational_space_id ServiceProvider#operational_space_id}
    */
    readonly operationalSpaceId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#password ServiceProvider#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#service_type ServiceProvider#service_type}
    */
    readonly serviceType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#url ServiceProvider#url}
    */
    readonly url?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider#user_name ServiceProvider#user_name}
    */
    readonly userName?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider ibmcpd_service_provider}
*/
export declare class ServiceProvider extends cdktf.TerraformResource {
    static readonly tfResourceType = "ibmcpd_service_provider";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/ibmcpd/r/service_provider ibmcpd_service_provider} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ServiceProviderConfig
    */
    constructor(scope: Construct, id: string, config: ServiceProviderConfig);
    private _apiKey?;
    get apiKey(): string;
    set apiKey(value: string);
    resetApiKey(): void;
    get apiKeyInput(): string | undefined;
    private _awsAccessKeyId?;
    get awsAccessKeyId(): string;
    set awsAccessKeyId(value: string);
    resetAwsAccessKeyId(): void;
    get awsAccessKeyIdInput(): string | undefined;
    private _awsRegion?;
    get awsRegion(): string;
    set awsRegion(value: string);
    resetAwsRegion(): void;
    get awsRegionInput(): string | undefined;
    private _awsSecretAccessKey?;
    get awsSecretAccessKey(): string;
    set awsSecretAccessKey(value: string);
    resetAwsSecretAccessKey(): void;
    get awsSecretAccessKeyInput(): string | undefined;
    private _deploymentSpaceId?;
    get deploymentSpaceId(): string;
    set deploymentSpaceId(value: string);
    resetDeploymentSpaceId(): void;
    get deploymentSpaceIdInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _operationalSpaceId?;
    get operationalSpaceId(): string;
    set operationalSpaceId(value: string);
    get operationalSpaceIdInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _serviceType?;
    get serviceType(): string;
    set serviceType(value: string);
    get serviceTypeInput(): string | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
    private _userName?;
    get userName(): string;
    set userName(value: string);
    resetUserName(): void;
    get userNameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
