import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#asset Subscription#asset}
    */
    readonly asset: SubscriptionAsset | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#asset_properties Subscription#asset_properties}
    */
    readonly assetProperties: SubscriptionAssetProperties | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#aws_access_key_id Subscription#aws_access_key_id}
    */
    readonly awsAccessKeyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#aws_region Subscription#aws_region}
    */
    readonly awsRegion?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#aws_secret_access_key Subscription#aws_secret_access_key}
    */
    readonly awsSecretAccessKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#data_mart_id Subscription#data_mart_id}
    */
    readonly dataMartId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#deployment Subscription#deployment}
    */
    readonly deployment: SubscriptionDeployment | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#name Subscription#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#payload_file Subscription#payload_file}
    */
    readonly payloadFile?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#service_provider_id Subscription#service_provider_id}
    */
    readonly serviceProviderId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#training_data_reference Subscription#training_data_reference}
    */
    readonly trainingDataReference?: SubscriptionTrainingDataReference | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#training_data_schema Subscription#training_data_schema}
    */
    readonly trainingDataSchema?: SubscriptionTrainingDataSchema[] | cdktf.IResolvable;
}
export interface SubscriptionAsset {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#asset_id Subscription#asset_id}
    */
    readonly assetId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#asset_type Subscription#asset_type}
    */
    readonly assetType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#input_data_type Subscription#input_data_type}
    */
    readonly inputDataType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#problem_type Subscription#problem_type}
    */
    readonly problemType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#url Subscription#url}
    */
    readonly url: string;
}
export declare function subscriptionAssetToTerraform(struct?: SubscriptionAsset | cdktf.IResolvable): any;
export declare class SubscriptionAssetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SubscriptionAsset | cdktf.IResolvable | undefined;
    set internalValue(value: SubscriptionAsset | cdktf.IResolvable | undefined);
    private _assetId?;
    get assetId(): string;
    set assetId(value: string);
    get assetIdInput(): string | undefined;
    private _assetType?;
    get assetType(): string;
    set assetType(value: string);
    get assetTypeInput(): string | undefined;
    private _inputDataType?;
    get inputDataType(): string;
    set inputDataType(value: string);
    get inputDataTypeInput(): string | undefined;
    private _problemType?;
    get problemType(): string;
    set problemType(value: string);
    get problemTypeInput(): string | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    get urlInput(): string | undefined;
}
export interface SubscriptionAssetProperties {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#categorical_fields Subscription#categorical_fields}
    */
    readonly categoricalFields: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#feature_fields Subscription#feature_fields}
    */
    readonly featureFields: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#label_column Subscription#label_column}
    */
    readonly labelColumn: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#prediction_field Subscription#prediction_field}
    */
    readonly predictionField: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#probability_fields Subscription#probability_fields}
    */
    readonly probabilityFields: string[];
}
export declare function subscriptionAssetPropertiesToTerraform(struct?: SubscriptionAssetProperties | cdktf.IResolvable): any;
export declare class SubscriptionAssetPropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SubscriptionAssetProperties | cdktf.IResolvable | undefined;
    set internalValue(value: SubscriptionAssetProperties | cdktf.IResolvable | undefined);
    private _categoricalFields?;
    get categoricalFields(): string[];
    set categoricalFields(value: string[]);
    get categoricalFieldsInput(): string[] | undefined;
    private _featureFields?;
    get featureFields(): string[];
    set featureFields(value: string[]);
    get featureFieldsInput(): string[] | undefined;
    private _labelColumn?;
    get labelColumn(): string;
    set labelColumn(value: string);
    get labelColumnInput(): string | undefined;
    private _predictionField?;
    get predictionField(): string;
    set predictionField(value: string);
    get predictionFieldInput(): string | undefined;
    private _probabilityFields?;
    get probabilityFields(): string[];
    set probabilityFields(value: string[]);
    get probabilityFieldsInput(): string[] | undefined;
}
export interface SubscriptionDeployment {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#deployment_id Subscription#deployment_id}
    */
    readonly deploymentId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#deployment_type Subscription#deployment_type}
    */
    readonly deploymentType: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#deployment_url Subscription#deployment_url}
    */
    readonly deploymentUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#name Subscription#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#scoring_url Subscription#scoring_url}
    */
    readonly scoringUrl?: string;
}
export declare function subscriptionDeploymentToTerraform(struct?: SubscriptionDeployment | cdktf.IResolvable): any;
export declare class SubscriptionDeploymentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SubscriptionDeployment | cdktf.IResolvable | undefined;
    set internalValue(value: SubscriptionDeployment | cdktf.IResolvable | undefined);
    private _deploymentId?;
    get deploymentId(): string;
    set deploymentId(value: string);
    get deploymentIdInput(): string | undefined;
    private _deploymentType?;
    get deploymentType(): string;
    set deploymentType(value: string);
    get deploymentTypeInput(): string | undefined;
    private _deploymentUrl?;
    get deploymentUrl(): string;
    set deploymentUrl(value: string);
    resetDeploymentUrl(): void;
    get deploymentUrlInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _scoringUrl?;
    get scoringUrl(): string;
    set scoringUrl(value: string);
    resetScoringUrl(): void;
    get scoringUrlInput(): string | undefined;
}
export interface SubscriptionTrainingDataReference {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#bucket_name Subscription#bucket_name}
    */
    readonly bucketName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#cos_api_key Subscription#cos_api_key}
    */
    readonly cosApiKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#cos_url Subscription#cos_url}
    */
    readonly cosUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#database_name Subscription#database_name}
    */
    readonly databaseName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#file_name Subscription#file_name}
    */
    readonly fileName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#hostname Subscription#hostname}
    */
    readonly hostname?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#iam_url Subscription#iam_url}
    */
    readonly iamUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#password Subscription#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#port Subscription#port}
    */
    readonly port?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#resource_instance_id Subscription#resource_instance_id}
    */
    readonly resourceInstanceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#schema_name Subscription#schema_name}
    */
    readonly schemaName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#ssl Subscription#ssl}
    */
    readonly ssl?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#table_name Subscription#table_name}
    */
    readonly tableName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#type Subscription#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#username Subscription#username}
    */
    readonly username?: string;
}
export declare function subscriptionTrainingDataReferenceToTerraform(struct?: SubscriptionTrainingDataReference | cdktf.IResolvable): any;
export declare class SubscriptionTrainingDataReferenceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): SubscriptionTrainingDataReference | cdktf.IResolvable | undefined;
    set internalValue(value: SubscriptionTrainingDataReference | cdktf.IResolvable | undefined);
    private _bucketName?;
    get bucketName(): string;
    set bucketName(value: string);
    resetBucketName(): void;
    get bucketNameInput(): string | undefined;
    private _cosApiKey?;
    get cosApiKey(): string;
    set cosApiKey(value: string);
    resetCosApiKey(): void;
    get cosApiKeyInput(): string | undefined;
    private _cosUrl?;
    get cosUrl(): string;
    set cosUrl(value: string);
    resetCosUrl(): void;
    get cosUrlInput(): string | undefined;
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    resetDatabaseName(): void;
    get databaseNameInput(): string | undefined;
    private _fileName?;
    get fileName(): string;
    set fileName(value: string);
    resetFileName(): void;
    get fileNameInput(): string | undefined;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    resetHostname(): void;
    get hostnameInput(): string | undefined;
    private _iamUrl?;
    get iamUrl(): string;
    set iamUrl(value: string);
    resetIamUrl(): void;
    get iamUrlInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    resetPort(): void;
    get portInput(): number | undefined;
    private _resourceInstanceId?;
    get resourceInstanceId(): string;
    set resourceInstanceId(value: string);
    resetResourceInstanceId(): void;
    get resourceInstanceIdInput(): string | undefined;
    private _schemaName?;
    get schemaName(): string;
    set schemaName(value: string);
    resetSchemaName(): void;
    get schemaNameInput(): string | undefined;
    private _ssl?;
    get ssl(): boolean | cdktf.IResolvable;
    set ssl(value: boolean | cdktf.IResolvable);
    resetSsl(): void;
    get sslInput(): boolean | cdktf.IResolvable | undefined;
    private _tableName?;
    get tableName(): string;
    set tableName(value: string);
    resetTableName(): void;
    get tableNameInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
}
export interface SubscriptionTrainingDataSchema {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#name Subscription#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#nullable Subscription#nullable}
    */
    readonly nullable: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription#type Subscription#type}
    */
    readonly type: string;
}
export declare function subscriptionTrainingDataSchemaToTerraform(struct?: SubscriptionTrainingDataSchema | cdktf.IResolvable): any;
export declare class SubscriptionTrainingDataSchemaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): SubscriptionTrainingDataSchema | cdktf.IResolvable | undefined;
    set internalValue(value: SubscriptionTrainingDataSchema | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _nullable?;
    get nullable(): boolean | cdktf.IResolvable;
    set nullable(value: boolean | cdktf.IResolvable);
    get nullableInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class SubscriptionTrainingDataSchemaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: SubscriptionTrainingDataSchema[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): SubscriptionTrainingDataSchemaOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription ibmcpd_subscription}
*/
export declare class Subscription extends cdktf.TerraformResource {
    static readonly tfResourceType = "ibmcpd_subscription";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/ibmcpd/r/subscription ibmcpd_subscription} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SubscriptionConfig
    */
    constructor(scope: Construct, id: string, config: SubscriptionConfig);
    private _asset;
    get asset(): SubscriptionAssetOutputReference;
    putAsset(value: SubscriptionAsset | cdktf.IResolvable): void;
    get assetInput(): cdktf.IResolvable | SubscriptionAsset | undefined;
    private _assetProperties;
    get assetProperties(): SubscriptionAssetPropertiesOutputReference;
    putAssetProperties(value: SubscriptionAssetProperties | cdktf.IResolvable): void;
    get assetPropertiesInput(): cdktf.IResolvable | SubscriptionAssetProperties | undefined;
    private _awsAccessKeyId?;
    get awsAccessKeyId(): string;
    set awsAccessKeyId(value: string);
    resetAwsAccessKeyId(): void;
    get awsAccessKeyIdInput(): string | undefined;
    private _awsRegion?;
    get awsRegion(): string;
    set awsRegion(value: string);
    resetAwsRegion(): void;
    get awsRegionInput(): string | undefined;
    private _awsSecretAccessKey?;
    get awsSecretAccessKey(): string;
    set awsSecretAccessKey(value: string);
    resetAwsSecretAccessKey(): void;
    get awsSecretAccessKeyInput(): string | undefined;
    private _dataMartId?;
    get dataMartId(): string;
    set dataMartId(value: string);
    get dataMartIdInput(): string | undefined;
    private _deployment;
    get deployment(): SubscriptionDeploymentOutputReference;
    putDeployment(value: SubscriptionDeployment | cdktf.IResolvable): void;
    get deploymentInput(): cdktf.IResolvable | SubscriptionDeployment | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _payloadFile?;
    get payloadFile(): string;
    set payloadFile(value: string);
    resetPayloadFile(): void;
    get payloadFileInput(): string | undefined;
    private _serviceProviderId?;
    get serviceProviderId(): string;
    set serviceProviderId(value: string);
    get serviceProviderIdInput(): string | undefined;
    private _trainingDataReference;
    get trainingDataReference(): SubscriptionTrainingDataReferenceOutputReference;
    putTrainingDataReference(value: SubscriptionTrainingDataReference | cdktf.IResolvable): void;
    resetTrainingDataReference(): void;
    get trainingDataReferenceInput(): cdktf.IResolvable | SubscriptionTrainingDataReference | undefined;
    private _trainingDataSchema;
    get trainingDataSchema(): SubscriptionTrainingDataSchemaList;
    putTrainingDataSchema(value: SubscriptionTrainingDataSchema[] | cdktf.IResolvable): void;
    resetTrainingDataSchema(): void;
    get trainingDataSchemaInput(): cdktf.IResolvable | SubscriptionTrainingDataSchema[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
